//gb_hidden_loc_hb
//heartbeat script to spawn location when player arrives
#include "ginc_debug"
#include "ginc_overland"

void PrepForDestruction(object oTarget)
{
	SetPlotFlag(oTarget,FALSE);
    SetImmortal(oTarget,FALSE);
    AssignCommand(oTarget,SetIsDestroyable(TRUE,FALSE,FALSE));
}

void RevealLocation(object oPC, object oFinder, int nSkill)
{
	MarkAsDone(OBJECT_SELF);
	effect eVis = EffectNWN2SpecialEffectFile("fx_teleport_new");
	location lLoc = GetLocation(OBJECT_SELF);
	string sGoodieTable = GetLocalString(OBJECT_SELF, "sGoodieTable");
	int nRow = GetLocalInt(OBJECT_SELF, "nRow");
	
	string sResRef = Get2DAString(sGoodieTable, "GOODIE_RESREF", nRow);
	string sName = GetStringByStrRef(Get2DAInt(sGoodieTable, "NAME_STRREF", nRow));
	
	object oNewGoodie = CreateObject(OBJECT_TYPE_PLACEABLE, sResRef, lLoc);
	string sFeedbackString = "<color=Gold>";
	sFeedbackString += GetStringByStrRef(Get2DAInt("skills", "Name",  nSkill));
	sFeedbackString += " (" + GetName(oFinder) + ")";
	sFeedbackString += ": ";
	sFeedbackString += GetLocalString(OBJECT_SELF, VAR_GOODIES_DISC_STR);
	sFeedbackString += "</color=Gold>";
	
	FloatingTextStringOnCreature(sFeedbackString, oPC, FALSE);
	SetGoodieData(oNewGoodie, sGoodieTable, nRow);
	PrepForDestruction(OBJECT_SELF);
	DestroyObject(OBJECT_SELF);
	
	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lLoc);	

}

void main()
{
	object oPC = GetFactionLeader(GetFirstPC());
	float fDetectRadius = GOODIE_DETECT_RADIUS;
	
	if(GetArea(oPC) != GetArea(OBJECT_SELF))
		return;
	
	float fDist = GetDistanceBetween(OBJECT_SELF, oPC);

	if( fDist > 40.0f)
		SetCustomHeartbeat(OBJECT_SELF, 9000);
	
	else if( fDist > 20.0f)
		SetCustomHeartbeat(OBJECT_SELF, 1000);
	
	else if( (fDist < fDetectRadius ||  GetGlobalInt("RevealGoodies")) && !IsMarkedAsDone())
	{
		int nSkill = GetLocalInt(OBJECT_SELF, VAR_GOODIES_DISC_SKILL);
		int nSkillDC = GetLocalInt(OBJECT_SELF, VAR_GOODIES_DISC_DC);
		object oFinder = GetBestSkill(nSkill);
		
		if ( GetSkillRank(nSkill, oFinder) >= nSkillDC || GetGlobalInt("RevealGoodies"))
		{
			RevealLocation(oPC, oFinder, nSkill);			
		}		
	}
}