//	gb_hidden_loc_hb
//	heartbeat script to spawn location when player arrives
void PrepForDestruction(object oTarget)
{
	SetPlotFlag(oTarget,FALSE);
    SetImmortal(oTarget,FALSE);
    AssignCommand(oTarget,SetIsDestroyable(TRUE,FALSE,FALSE));
}

#include "ginc_debug"
#include "ginc_overland"

void GrantXP(object oPC)
{
	object oMember	= GetFirstFactionMember(oPC);
	int nXP			= 100;
	
	while (GetIsObjectValid(oMember))
	{
		GiveXPToCreature(oMember, nXP);
		oMember		= GetNextFactionMember(oPC);
	}
}

//	nAlertPlayer determines whether or not notification text is displayed
//	for a location's discovery.
void RevealLocation(object oPC, object oFinder, int nAlertPlayer)
{
	string sResRef = GetTravelPlaceableResRef();
//	string sNotify;
	location lLoc = GetLocation(OBJECT_SELF);
	effect eVis = EffectNWN2SpecialEffectFile("fx_teleport_new");
	
	PrepForDestruction(OBJECT_SELF);
	DestroyObject(OBJECT_SELF);
	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lLoc);
	object oLoc = CreateObject(OBJECT_TYPE_PLACEABLE, sResRef, lLoc);
	
	object oWP = GetObjectByTag(GetExitWPTag());
	
	//	Notifies the PC that a location has been revealed
	//	and enables the location's mapnote.
	if(GetIsObjectValid(oWP))
	{
		PrettyDebug("valid waypoint... enabling");
		
		/*	Send message to player letting him know he's found something
			if nAlertPlayer is TRUE	*/
		if (nAlertPlayer == TRUE)
		{
			string sFeedbackString = "<color=Gold>";
			sFeedbackString += GetStringByStrRef(Get2DAInt("skills", "Name",  SKILL_SEARCH));
			sFeedbackString += " (" + GetName(oFinder) + ")";
			sFeedbackString += ": ";
			sFeedbackString += GetStringByStrRef(220802) + GetName(oLoc);
			sFeedbackString += "</color=Gold>";

			FloatingTextStringOnCreature(sFeedbackString, oPC, FALSE);
			GrantXP(oPC);
			PlaySound("gui_magbag_full", TRUE);
		}
		
		SetMapPinEnabled(oWP, TRUE);
	}
}

void main()
{
	object oPC = GetFactionLeader(GetFirstPC());
	float fDist = GetLocalFloat(OBJECT_SELF, "fDist");
	string sResRef = GetTravelPlaceableResRef();
		
	if (GetArea(oPC) != GetArea(OBJECT_SELF))
		return;
	
	if( GetCustomHeartbeat(OBJECT_SELF) != 250)
		SetCustomHeartbeat(OBJECT_SELF, 250);
	
	if( GetGlobalInt(sResRef+"_DISCOVERED"))
		RevealLocation(oPC, oPC, FALSE);
	
	else if( GetDistanceBetween(OBJECT_SELF, oPC) < fDist)
	{
		int iSpotDC = GetLocalInt(OBJECT_SELF, "iSpotDC");
		object oFinder = GetBestSkill(SKILL_SEARCH);
		//	Uses Search skill, despite the name of the variable.
		if ( GetSkillRank(SKILL_SEARCH, oFinder) >= iSpotDC )
		{
			SetGlobalInt(sResRef + "_DISCOVERED", TRUE);
			RevealLocation(oPC, oFinder, TRUE);
		}
		
		/*	Auto-reveal the hotspot if the player walks on top of it, unless the DC is
			set to 100.	*/
		else if ( GetDistanceBetween(OBJECT_SELF, oPC) <= 1.5f 
				  && iSpotDC < 100)		
		{
			SetGlobalInt(sResRef + "_DISCOVERED", TRUE);
			RevealLocation(oPC, oPC, TRUE);
		}
	}
}